---
title: elm-pages - a statically typed site generator
type: page
---

<Banner>A **statically typed** site generator</Banner>

<Boxes>
<Box>
### Pure Elm Configuration

Layouts, styles, even a full-fledged elm application.

### 📄 Type-Safe Content

Configuration, errors for broken links
</Box>
<Box>

### 🚀 `elm-pages build`

No `elm make` or `webpack` setup needed! Just one simple command.

</Box>
<Box>

### 📦 Optimized Elm Progressive Web App

Layouts, styles, even a full-fledged elm application.

### Deploy anywhere

Ship to Netlify,
</Box>
</Boxes>

<Values>
<Value>
# No magic, just types

The magic is in how the pieces snap together. The basic platform provided is simple, letting you compose exactly what you need with types to support you.
</Value>

<Value>
# Extensible through pure elm

Behavior is shared through packages exposing simple helper functions to help you build up your data.
</Value>

<Value>
# If it compiles, it works

`elm-pages` just makes more of the things you do in your static site feel like elm. Did you misspell the name of an image asset or a link to a blog post? `elm-pages` will give you a friendly error message and some helpful suggestions.
</Value>

<Value>
# An extended elm platform

`elm-pages` is just elm, but with a broader set of primitives for declaring meta tags to improve SEO, or generate RSS feeds and other files based on your static content.
</Value>

<Value>
# Blazing fast

All you have to do is create your content and choose how to present it. Optimized images, pre-rendered pages, and a snappy lightweight single-page app all come for free.
</Value>

<Value>
# Simple

`elm-pages` gives you the smallest set of core concepts possible, and a type system to make sure all the pieces fit together just right. The rest is up to you. Rather than remember a lot of magic and special cases, you can just rely on your elm types to build what you need with a set of simple primitives.
</Value>
</Values>
